{$A-,B-,D-,F-,G+,I-,K-,L-,N-,P-,Q-,R-,S-,T-,V-,W-,X+,Y-}
{$M 16192,32768}

program RegSub;

uses
  WinTypes, SysUtils;

function IsRegKey(const s: string): boolean;
begin
  Result := (Length(s) > 2) and (s[1] = '[') and (s[Length(s)] = ']');
end;

function NextRegKey(const f: text): string;
begin
  repeat ReadLn(f,Result) until IsRegKey(Result) or EOF(f);
  if EOF(f) then Result := '';
end;

const
  REGFILE_HEADER = 'REGEDIT4';

var
  f1,f2,f3: text;
  s1,s2: string;
  b: boolean;

begin
  if ParamCount < 3 then begin
    MessageBox(
      GetActiveWindow,
      'Use syntax: RegSub file1 file2 ResultFile [/nomessage]'#13#13#10'to subtract file2 from file1 to ResultFile'#13#13#10'(file1 - file2 = ResultFile)'#13#13#10'/nomessage optional key block the final message.',
      'RegSub: syntax error',
      MB_ICONINFORMATION OR MB_OK
    );
    Halt(1);
  end;
  if not FileExists(ParamStr(1)) then begin
    MessageBox(GetActiveWindow,'file1 not found','RegSub: error',MB_ICONERROR OR MB_OK);
    Halt(2);
  end;
  if not FileExists(ParamStr(2)) then begin
    MessageBox(GetActiveWindow,'file2 not found','RegSub: error',MB_ICONERROR OR MB_OK);
    Halt(3);
  end;
  if FileExists(ParamStr(3)) then begin
    if MessageBox(GetActiveWindow,'ResultFile already present. Overwrite?','RegSub: confirm',MB_ICONQUESTION OR MB_OKCANCEL) <> ID_OK then begin
      Halt(4);
    end;
  end;

  AssignFile(f1,ParamStr(1)); Reset(f1);
  ReadLn(f1,s1);
  if s1 <> REGFILE_HEADER then begin
    MessageBox(GetActiveWindow,'file1 is not registry file','RegSub: error',MB_ICONERROR OR MB_OK);
    Close(f1);
    Halt(5);
  end;
  AssignFile(f2,ParamStr(2)); Reset(f2);
  ReadLn(f2,s2);
  if s1 <> REGFILE_HEADER then begin
    MessageBox(GetActiveWindow,'file2 is not registry file','RegSub: error',MB_ICONERROR OR MB_OK);
    Close(f1); Close(f2);
    Halt(6);
  end;

  //  file2 > file1    file2  file1
  if FileSize(f1) < FileSize(f2) then begin
    Close(f1);
    Close(f2);
    AssignFile(f1,ParamStr(2)); Reset(f1); ReadLn(f1,s1);
    AssignFile(f2,ParamStr(1)); Reset(f2); ReadLn(f2,s2);
  end;

  //       
  AssignFile(f3,ParamStr(3)); Rewrite(f3);
  WriteLn(f3,REGFILE_HEADER);
  WriteLn(f3);


  while not (EOF(f1) or EOF(f2)) do begin
    s1 := NextRegKey(f1);
    s2 := NextRegKey(f2);
    if s1 <> s2 then begin
      WriteLn(f3,s1);
      repeat
        ReadLn(f1,s1);
        b := IsRegKey(s1) and (s1 = s2);
        if not b then WriteLn(f3,s1);
      until EOF(f1) or b;
      WriteLn(f3);
    end;
  end;

  Close(f1);
  Close(f2);
  Close(f3);

  if UpperCase(ParamStr(4)) <> '/NOMESSAGE' then MessageBox(GetActiveWindow,'file1 succesfully substracted from file2!','RegSub: success',MB_ICONINFORMATION OR MB_OK);
end.




